//Ghille hates this weapon so much. Ghille wishes this weapon would burn and Ghille wishes he would quit talking in third person to himself for a code nobody will read. Ghille needs a life.

datablock AudioProfile(CZFireSound)
{
   filename    = "./CZFire.wav";
   description = AudioClosest3d;
   preload = true;
};


AddDamageType("CZ",   '<bitmap:add-ons/Weapon_TacticalWeps/CI_CZ> %1',    '%2 <bitmap:add-ons/Weapon_TacticalWeps/CI_CZ> %1',0.2,1);
datablock ProjectileData(CZProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::CZ;
   radiusDamageType    = $DamageType::CZ;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse      = 400;
   verticalImpulse   = 400;
   explosion           = vectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.34;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "CZ Bullet";
};
//////////
// item //
//////////
datablock ItemData(CZItem)
{
 category = "Weapon";  // Mission editor category
 className = "Weapon"; // For inventory system
  // Basic Item Properties
 shapeFile = "./CZ.dts";
 rotate = false;
 mass = 1;
 density = 0.2;
 elasticity = 0.2;
 friction = 0.6;
 emap = true;
 //gui stuff
 uiName = "CZ75";
 iconName = "./UI_CZ";
 doColorShift = true;
 colorShiftColor = "0.25 0.25 0.25 1.000";
  // Dynamic properties defined by the scripts
 image = CZImage;
 canDrop = true;
        maxAmmo = 10;
        canReload = 1;
};
////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(CZImage)
{
   // Basic Item properties
   shapeFile = "./CZ.dts";
   emap = true;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   // Projectile && Ammo.
   item = CZItem;
   ammo = " ";
   projectile = CZProjectile;
   projectileType = Projectile;
 casing = gunShellDebris;
 shellExitDir        = "1.0 -1.3 1.0";
 shellExitOffset     = "0 0 0";
 shellExitVariance   = 15.0; 
 shellVelocity       = 7.0;
   melee = false;
   armReady = true;
   doColorShift = true;
   colorShiftColor = CZItem.colorShiftColor;//"0.400 0.196 0 1.000";
   casing = gunShellDebris;

 stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateEmitter[2]    = vectorFlashEmitter;
 stateEmitterTime[2]   = 0.06;
 stateEmitterNode[2]   = "muzzleNode";
 stateSound[2]    = CZFireSound;
  stateEjectShell[2] = true;  
 
 stateName[4]    = "LoadCheckA";
 stateScript[4]    = "onLoadCheck";
 stateTimeoutValue[4]   = 0.01;
 stateTransitionOnTimeout[4]  = "LoadCheckB";
 
 stateName[5]    = "LoadCheckB";
 stateTransitionOnAmmo[5]  = "Ready";
 stateTransitionOnNoAmmo[5]  = "Reload";
 stateName[6]    = "Reload";
 stateTimeoutValue[6]   = 0.6;
 stateScript[6]    = "onReloadStart";
 stateTransitionOnTimeout[6]  = "Wait";
 stateWaitForTimeout[6]   = true;
 stateSound[6]    = HBlock_MoveBrick_Sound;
 
 stateName[7]    = "Wait";
 stateTimeoutValue[7]   = 0.4;
 stateScript[7]    = "onReloaded";
 stateTransitionOnTimeout[7]  = "Ready";
 stateSound[7]    = HBlock_PlantBrick_Sound;
 
 stateName[8]    = "FireLoadCheckA";
 stateScript[8]    = "onLoadCheck";
 stateTimeoutValue[8]   = 0.01;
 stateTransitionOnTimeout[8]  = "FireLoadCheckB";
 
 stateName[9]    = "FireLoadCheckB";
 stateTransitionOnAmmo[9]  = "Smoke";
 stateTransitionOnNoAmmo[9]  = "ReloadSmoke";
 
 stateName[10]     = "Smoke";
 stateEmitter[10]   = gunSmokeEmitter;
 stateEmitterTime[10]   = 0.3;
 stateEmitterNode[10]   = "muzzleNode";
 stateTimeoutValue[10]   = 0.2;
 stateTransitionOnTriggerUp[10]     = "Ready";
 
 stateName[11]     = "ReloadSmoke";
 stateEmitter[11]   = gunSmokeEmitter;
 stateEmitterTime[11]   = 0.3;
 stateEmitterNode[11]   = "muzzleNode";
 stateTimeoutValue[11]   = 0.2;
 stateTransitionOnTimeout[11]  = "Reload";
 
};
function CZImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function CZImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "10 " @ "", 4, 2, 3, 4); 
}
function CZImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function CZImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "10 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, shiftAway);
                                
%projectile = %this.projectile;
  %spread = 0.0020;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}
